def find_circuit_name_with_first_quenched_magnet(circuit_names, u_diode_rqd, u_diode_rqf, u_threshold=1):
    t_threshold_rqd = u_diode_rqd[u_diode_rqd.values > u_threshold].index[0]
    t_threshold_rqf = u_diode_rqf[u_diode_rqf.values > u_threshold].index[0]

    return circuit_names[0] if t_threshold_rqd < t_threshold_rqf else circuit_names[1]


def find_t_start_t_end_voltage_slope(u_qs0_df, u_slope_start=0.01, u_slope_end=0.1):
    u_qs0_df = abs(u_qs0_df)
    t_first_max = u_qs0_df.idxmax().values[0]
    u_qs0_short_df = u_qs0_df[u_qs0_df.index < t_first_max]
    t_slope_start = u_qs0_short_df[u_qs0_short_df < u_slope_start].dropna().index[-1]
    t_slope_end = u_qs0_short_df[u_qs0_short_df < u_slope_end].dropna().index[-1]
    return t_slope_start, t_slope_end


def calculate_voltage_slope(u_qs0_aperture_df, t_slope_start, t_slope_end):
    u_qs0_slope_df = u_qs0_aperture_df[(u_qs0_aperture_df.index >= t_slope_start) &
                                       (u_qs0_aperture_df.index <= t_slope_end)]
    du_dt =  (u_qs0_slope_df.values[-1] - u_qs0_slope_df.values[0]) / (u_qs0_slope_df.index[-1] - u_qs0_slope_df.index[0])
    return float(du_dt)


def choose_u_qs0(aperture, u_qs0_int_rq_df, u_qs0_ext_rq_df):
    return u_qs0_int_rq_df if aperture == 'INT' else u_qs0_ext_rq_df